/*------------------------------------------------------------------------------
#
#	ClientAppli.h	-	Rez and C Include Source
#
#	derived from MPW 3.1's "Sample", a MultiFinder-Aware Simple Sample Application
#   ClientAppli.c and ClientAppli.r include this file.
#
#   Refer to the original source code in the MPW CExamples folder for more comments
#
#	Components:
#				ClientAppli.c
#				ClientAppli.r
#				ClientAppli.h
#				ClientAppli.make
#
------------------------------------------------------------------------------*/

/* This are the A/ROSE message codes we define: */

#define DUMMYCODE	900
#define RESETCODE	998
/* .............................................*/


#define kMinSize	23				/* application's minimum size (in K) */
#define kPrefSize	35				/* application's preferred size (in K) */

#define	rMenuBar	128				/* application's menu bar */
#define	rAboutAlert	128				/* about alert */
#define	rUserAlert	129				/* error user alert */
#define	rWindow		128				/* application's window */

#define	rResetBtn	128				/* Reset counts button */
#define	rSendBtn	129				/* Send message button */

#define	rErrStrings	128				/* error string list  */
#define	rWndStrings 129				/* window string list */

#define	rTaskName	128				/* task object Name 'STR ' rsrc id  -- this is the "server" */
#define	rTaskType	129				/* task type Name 'STR ' rsrc id */
#define	rClientName	130				/* the same for the "client" */
#define	rClientType	131				

/* The following are indicies into STR# resources. */
#define	eWrongMachine			1
#define	eSmallSize				2
#define	eNoMemory				3
#define	eNoWindow				4
#define	eNoAROSE				5
#define	eRegister				6
#define	eNoMsg					7
#define	eNoServer				8
#define	eICCMproblem			9
#define	eUnknownMsg				10
#define	eUndeliverable			11
#define kLastErrStr				11				/* last index in STR# */


#define	kSysEnvironsVersion		1

#define	kOSEvent				app4Evt	/* event used by MultiFinder */
#define	kSuspendResumeMessage	1		/* high byte of suspend/resume event message */
#define	kResumeMask				1		/* bit of message field for resume vs. suspend */
#define	kMouseMovedMessage		0xFA	/* high byte of mouse-moved event message */
#define	kNoEvents				0		/* no events mask */

#define	mApple					128		/* Apple menu */
#define	iAbout					1

#define	mFile					129		/* File menu */
#define	iNew					1
#define	iClose					4
#define	iQuit					12

#define	mEdit					130		/* Edit menu */
#define	iUndo					1
#define	iCut					3
#define	iCopy					4
#define	iPaste					5
#define	iClear					6

#define	mSleep					131		/* MultiFinder SleepTime menu */
#define	iNoSleep				1
#define	i60Ticks				2

/*	This is for positioning the Disk Initialization dialogs. */

#define kDITop					0x0050
#define kDILeft					0x0070

#define kMinHeap				21 * 1024
#define kMinSpace				8 * 1024

/* these #defines are used to set enable/disable flags of a menu */

#define AllItems	0b1111111111111111111111111111111	/* 31 flags */
#define NoItems		0b0000000000000000000000000000000
#define MenuItem1	0b0000000000000000000000000000001
#define MenuItem2	0b0000000000000000000000000000010
#define MenuItem3	0b0000000000000000000000000000100
#define MenuItem4	0b0000000000000000000000000001000
#define MenuItem5	0b0000000000000000000000000010000
#define MenuItem6	0b0000000000000000000000000100000
#define MenuItem7	0b0000000000000000000000001000000
#define MenuItem8	0b0000000000000000000000010000000
#define MenuItem9	0b0000000000000000000000100000000
#define MenuItem10	0b0000000000000000000001000000000
#define MenuItem11	0b0000000000000000000010000000000
#define MenuItem12	0b0000000000000000000100000000000
